<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="工厂" prop="factory">
        <el-input v-model="formData.factory" placeholder="请输入工厂" disabled/>
      </el-form-item>
      <el-form-item label="成本中心" prop="costCenter">
        <el-input v-model="formData.costCenter" placeholder="请输入成本中心" disabled/>
      </el-form-item>
      <el-form-item label="物料编码" prop="materialCode">
        <el-input v-model="formData.materialCode" placeholder="请输入物料编码" disabled/>
      </el-form-item>
      <el-form-item label="物料名称" prop="materialName">
        <el-input v-model="formData.materialName" placeholder="请输入物料名称" disabled/>
      </el-form-item>
      <el-form-item label="数量" prop="quantity">
        <el-input v-model="formData.quantity" placeholder="请输入数量" />
      </el-form-item>
      <el-form-item label="单价" prop="unitPrice">
        <el-input v-model="formData.unitPrice" placeholder="请输入单价" />
      </el-form-item>
      <el-form-item label="单位" prop="unit">
        <el-input v-model="formData.unit" placeholder="请输入单位" disabled/>
      </el-form-item>
      <el-form-item label="入库时间" prop="storageTime">
        <el-date-picker
          v-model="formData.storageTime"
          type="date"
          value-format="x"
          placeholder="选择入库时间"
          disabled
        />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotLockStockApi, IotLockStockVO } from '@/api/pms/iotlockstock'

/** PMS 本地 库存 表单 */
defineOptions({ name: 'IotLockStockForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deptId: undefined,
  factory: undefined,
  projectDepartment: undefined,
  costCenter: undefined,
  pickingListNumber: undefined,
  materialCode: undefined,
  materialName: undefined,
  materialGroupName: undefined,
  materialGroupId: undefined,
  quantity: undefined,
  unitPrice: undefined,
  unit: undefined,
  storageTime: undefined,
  sort: undefined,
  status: undefined,
  processInstanceId: undefined,
  auditStatus: undefined,
  remark: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotLockStockApi.getIotLockStock(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotLockStockVO
    if (formType.value === 'create') {
      await IotLockStockApi.createIotLockStock(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotLockStockApi.updateIotLockStock(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deptId: undefined,
    factory: undefined,
    projectDepartment: undefined,
    costCenter: undefined,
    pickingListNumber: undefined,
    materialCode: undefined,
    materialName: undefined,
    materialGroupName: undefined,
    materialGroupId: undefined,
    quantity: undefined,
    unitPrice: undefined,
    unit: undefined,
    storageTime: undefined,
    sort: undefined,
    status: undefined,
    processInstanceId: undefined,
    auditStatus: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
